<template>
  <v-layout>
    <v-flex xs12>
      <v-data-table
        class="elevation-3"
        item-key="provisionId"
        :headers="headers"
        :items="provisions"
        :footer-props="{
          itemsPerPageOptions: [10, 25, 50, 100, -1],
        }"
      >
        <template v-slot:body.prepend="{ isMobile }">
          <tr>
            <td :class="isMobile ? 'v-data-table__mobile-row' : ''">
              <v-autocomplete
                clearable
                height="25"
                color="secondary"
                v-model.trim="filterPointAddress"
                label="Пункт доставки"
                :items="points"
                item-text="item"
                item-value="value"
              ></v-autocomplete>
            </td>
            <td :class="isMobile ? 'v-data-table__mobile-row' : ''">
              <v-text-field
                clearable
                height="25"
                color="secondary"
                v-model="filterManufacturer"
                label="Производитель"
              ></v-text-field>
            </td>
            <td :class="isMobile ? 'v-data-table__mobile-row' : ''">
              <v-text-field
                clearable
                height="25"
                color="secondary"
                v-model="filterProductName"
                label="Наименование"
              ></v-text-field>
            </td>
          </tr>
        </template>

        <template v-slot:item.start="{ item }">
          {{ item.start | date }}
        </template>

        <template v-slot:item.end="{ item }">
          {{ item.end | date }}
        </template>

        <template v-slot:item.actions="{ item }">
          <v-btn icon @click="deleteProvision(item.provisionId)">
            <v-icon>{{ icons.delete }}</v-icon>
          </v-btn>
        </template>

        <template v-slot:no-data>
          <v-alert :value="true" type="warning">Записи не найдены</v-alert>
        </template>
      </v-data-table>
    </v-flex>
  </v-layout>
</template>

<script>
import { Icon } from "@/helpers";

export default {
  props: {
    provisions: {
      type: Array,
      required: true,
    },
  },
  computed: {
    headers() {
      return [
        {
          text: "Пункт доставки",
          value: "pointAddress",
          filter: (value) => {
            if (this.filterPointAddress !== null)
              if (!this.filterPointAddress) return true;

            // return value.search(new RegExp(this.filterPointAddress, "i")) > -1;
            return value === this.filterPointAddress;
          },
        },
        {
          text: "Производитель",
          value: "manufacturer",
          filter: (value) => {
            if (!this.filterManufacturer) return true;

            return value.search(new RegExp(this.filterManufacturer, "i")) > -1;
          },
        },
        {
          text: "Наименование",
          value: "productName",
          filter: (value) => {
            if (!this.filterProductName) return true;

            if (value != null)
              return value.search(new RegExp(this.filterProductName, "i")) > -1;
          },
        },
        {
          text: "Дата начала",
          value: "start",
        },
        {
          text: "Дата завершения",
          value: "end",
        },
        {
          text: "Сумма, РОЦ",
          value: "price",
          align: "right",
          // width: "8%"
        },
        {
          text: "Количество",
          value: "quantity",
          align: "right",
          // width: "9%"
        },
        { text: "", value: "actions", sortable: false },
      ];
    },
    points: function () {
      // return [...new Set(this.provisions.map(x => x.pointAddress))].sort();
      const result = [];
      const map = new Map();
      for (const item of this.provisions) {
        if (!map.has(item.pointAddress)) {
          map.set(item.pointAddress, true);
          result.push({
            item: item.pointAddress === null ? "" : item.pointAddress,
            value: item.pointAddress,
          });
        }
      }

      return result;
    },
  },
  methods: {
    deleteProvision: function (item) {
      this.$emit("delete-provision", item);
    },
  },
  data: () => ({
    filterPointAddress: "",
    filterManufacturer: "",
    filterProductName: "",
    icons: {
      delete: Icon.delete,
    },
  }),
  mounted() {},
};
</script>
